; -----------------------------------------------
; COMPUTES A 32 BITS HASH VALUE FOR A STRING
; NASM assembler
; By Jacques Philippe         February 13th, 2005
; -----------------------------------------------
; PROC NAME : HASH32BIT
;    - first argument is a pointer to the string
;    - returns the Hash Value
; -----------------------------------------------
; Header
    bits 32
; ---- Macros -----------------------------------
    %define RqBinDatas [ebp+8]
; ---- End Macros -------------------------------
  segment .text
    start:
    push ebp                            ; enter 0, 0
    mov ebp, esp
; End of Header
; ==== Function =================================
         mov       esi,      RqBinDatas
         mov       ecx,      [esi-4]             ; ecx is Len(RqBinDatas)
         xor       edx,      edx
         xor       eax,      eax
         inc       ecx                           ; Char Counter + 1
         cld
    .compute_hash_again:
         lodsb                                   ; al = [ds:esi] ds=0 in Flat mode & cld >>> inc esi
         dec       ecx
         jz        .compute_hash_finished
         ror       edx,      0xd
         add       edx,      eax
         jmp       .compute_hash_again
    .compute_hash_finished:
         mov       eax,      edx
; ===== End of Function =========================
; Footer    
    mov esp, ebp                        ; equiv to Leave
    pop ebp
    ret 16                              ; always 4 arguments with API CallWindowProcA + MeCodePtr
; End of Footer
; *** End of NASM Code
